<template>
  <div class="detail-section" :class="{ mobile: isMobile() }">
    <div style="position: relative" v-if="!isMobile()" class="header-section d-flex align-items-end">
      <img :src="playlistInfo.cover" class="cover-img" />
      <a-row class="flex-grow-1 d-flex align-items-end">
        <a-col :span="6" class="playlist-cover-wrap">
          <img :src="playlistInfo.cover" />
        </a-col>
        <a-col :span="18">
          <div class="header">
            <span><b>PLAYLIST</b></span
            ><br />
            <span class="title-playlist"
              ><b>{{ playlistInfo.name }}</b></span
            ><br />
            <span
              ><b>{{ playlistInfo.description }}</b></span
            ><br />
            <span>{{ playlistInfo.song }} Tracks - {{ playlistInfo.like }} Likes - {{ playlistInfo.view }} Views</span>
          </div>
        </a-col>
      </a-row>
    </div>
    <div class="content" style="text-align: left; display: block; margin: 0 auto">
      <a-row v-if="!isMobile()" class="mb-4">
        <a-col
          :span="16"
          style="text-align: left; margin-top: 20px; font-size: 1.2em; display: flex; flex-wrap: wrap; flex-direction: row; justify-content:start"
        >
          <a-button class="btn-play-music" @click="playPlaylist"><a-icon type="caret-right"/></a-button>
          <span style="font-size: 32px; align-self: center; cursor: pointer; opacity: .5;"><a-icon type="heart"/></span>
          <span style="font-size: 32px; align-self: center; margin-left: 24px; cursor: pointer; opacity: .5"
            ><a-icon type="ellipsis"
          /></span>
        </a-col>
        <a-col :span="8" style="float: right"></a-col>
      </a-row>
      <div class="playlist-detail" v-if="isMobile()">
        <img :src="playlistInfo.cover" class="playlist-bg" />
        <img :src="playlistInfo.cover" class="playlist-cover" />
        <p class="playlist-name">{{ playlistInfo.name }}</p>
        <div>
          <span>{{ playlistInfo.song }} Track</span><span class="dot">.</span>
          <span>{{ playlistInfo.like }} <a-icon type="heart"></a-icon></span><span class="dot">.</span>
          <span>{{ playlistInfo.view }} <a-icon type="customer-service"></a-icon></span>
        </div>
      </div>
      <a-table
        v-if="!isMobile()"
        :columns="tbColumn"
        :data-source="listMusic"
        :pagination="false"
        :customRow="handleClickRow"
      >
        <span slot="play" style="color:#808080"
          ><img src="play-btn.svg" style="width: 30px; height: 30px; cursor: pointer"
        /></span>
        <span slot="name" slot-scope="name" style="color:#808080;">{{ name }}</span>
        <span slot="artist" slot-scope="artist" style="color:#808080">{{ artist }}</span>
        <span slot="date" slot-scope="date" style="color:#808080">{{ date }}</span>
        <span slot="duration" slot-scope="duration" style="color:#808080">{{ duration }}</span>
      </a-table>
      <a-table
        v-if="isMobile()"
        class="table-playlist"
        :columns="tbColumnMobile"
        :data-source="listMusic"
        :pagination="false"
        :showHeader="false"
        :customRow="handleClickRow"
      >
        <span
          slot="name"
          slot-scope="name"
          class="name"
          style="width: 40vw; overflow: hidden; display: inline-block; text-overflow: ellipsis;"
          >{{ name }}</span
        >
        <span slot="artist" slot-scope="artist" style="width: 20vw; overflow: hidden; display: inline-block; text-overflow: ellipsis;">{{
          artist
        }}</span>
        <span slot="duration" slot-scope="duration">{{ duration }}</span>
      </a-table>
    </div>
  </div>
</template>

<style scoped>
.detail-section:not(.mobile) {
  padding-bottom: 100px;
}
.detail-section.mobile {
  padding-bottom: 60px;
}
.header-section {
  height: 340px;
  overflow: hidden;
  padding: 0 0 24px;
}
.header-section .cover-img {
  width: 100%;
  height: 100%;
  object-fit: cover;
  filter: blur(10px) brightness(0.7);
  position: absolute;
  left: 0;
  top: 0;
}
.header-section .playlist-cover-wrap img {
  width: 232px;
  height: 232px;
  object-fit: cover;
  box-shadow: 0 4px 60px rgb(0 0 0 / 50%);
}
.header-section .header {
  height: 100%;
  width: 100%;
  text-align: left;
}
.header-section .header .title-playlist {
  font-size: 56px;
  white-space: nowrap;
  overflow: hidden;
  width: 90%;
  text-overflow: ellipsis;
  display: inline-block;
}
h1 {
  color: blue;
}
.mobile td {
  border-bottom: none !important;
}
.content {
  width: 95%;
}
.mobile .content {
  width: 100%;
}
.detail-section {
  padding-bottom: 30px;
}
.header-item {
  float: right;
  margin-top: 30px;
}
.header-item li {
  display: inline;
  margin-left: 50px;
}
.header-item li:hover {
  cursor: pointer;
  background: chartreuse;
}
.btn-play-music {
  background-color: #1db954 !important;
  border: none !important;
  color: #fff !important;
  border-radius: 50%;
  padding: 0;
  width: 64px;
  height: 64px;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  margin-right: 32px;
}
.btn-play-music:hover {
  transition: all 0.3s ease;
  transform: scale(1.1);
}
.btn-play-music i {
  font-size: 40px;
  margin-left: 4px;
  margin-top: 8px;
}
.get {
  padding-top: 10px;
  padding-bottom: 10px;
  padding-left: 20px;
  padding-right: 20px;
  border-radius: 10px;
  background: #1db954;
  color: #fff;
  font-weight: bold;
}
.playlist-detail {
  display: flex;
  flex-direction: column;
  align-items: center;
  position: relative;
  padding: 22px 24px 60px;
  overflow: hidden;
}
.playlist-detail::after {
  content: "";
  position: absolute;
  left: 0;
  bottom: -6px;
  width: 100%;
  height: 120px;
  background: linear-gradient(0deg, #121212ff 0%, #12121200 100%);
}
.playlist-detail > * {
  position: relative;
}
.playlist-detail .playlist-bg {
  width: 100%;
  height: 130%;
  object-fit: cover;
  filter: blur(10px) brightness(0.5);
  position: absolute;
  left: 0;
  top: 0;
}
.playlist-detail .playlist-cover {
  width: 160px;
  height: 160px;
  object-fit: cover;
  margin-bottom: 6px;
}
.playlist-detail .playlist-name {
  font-weight: 600;
  font-size: 32px;
  text-align: center;
  letter-spacing: -0.24px;
  color: #f1f1f1;
  margin: 0 22px;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}
.playlist-detail div .dot {
  line-height: 10px;
  font-size: 40px;
  margin-left: 2px;
  padding-bottom: 2px;
}
.mobile .table-playlist .name {
  font-weight: 500;
  font-size: 16px;
  color: #f1f1f1;
}
</style>
<style>
.detail-section.mobile .ant-table-tbody td {
  border-bottom: none !important;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}
</style>

<script>
import service from "../service.js";
import { Howl } from "howler";

const tbColumn = [
  {
    title: "Play",
    key: "play",
    dataIndex: "play",
    scopedSlots: { customRender: "play" }
  },
  {
    title: "Name",
    key: "name",
    dataIndex: "name",
    scopedSlots: { customRender: "name" }
  },
  {
    title: "Artist",
    key: "artist",
    dataIndex: "artist",
    scopedSlots: { customRender: "artist" }
  },
  {
    title: "Date",
    key: "date",
    dataIndex: "date",
    scopedSlots: { customRender: "date" }
  },
  {
    title: "Duration",
    key: "duration",
    dataIndex: "duration",
    scopedSlots: { customRender: "duration" }
  }
];
const tbColumnMobile = [
  {
    title: "Name",
    key: "name",
    dataIndex: "name",
    scopedSlots: { customRender: "name" }
  },
  {
    title: "Artist",
    key: "artist",
    dataIndex: "artist",
    scopedSlots: { customRender: "artist" }
  },
  {
    title: "Duration",
    key: "duration",
    dataIndex: "duration",
    scopedSlots: { customRender: "duration" }
  }
];

export default {
  data() {
    return {
      listGenre: [],
      playlistId: null,
      playlistInfo: {},
      listMusic: [
        {
          id: 0,
          key: 0,
          name: "Song",
          artist: "Unknown",
          date: "",
          duration: "0:00",
          play: ""
        }
      ],
      tbColumn: tbColumn,
      tbColumnMobile: tbColumnMobile
    };
  },
  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true;
      } else {
        return false;
      }
    },
    playPlaylist() {
      let music = this.listMusic[0];

      const { id, play: url, name: title, artist, photo } = music;
      this.playMusic({ id, url, title, artist, photo });
    },
    handleClickRow(record) {
      return {
        on: {
          click: (event) => {
            const { id, play: url, name: title, artist, photo } = record;
            this.playMusic({ id, title, url, artist, photo });
          }
        }
      };
    },
    playMusic(music) {
      this.$store.dispatch("player/playMusic", music);
      console.log(music)
      this.$store.commit('player/setPlaylist', this.listMusic);
    },
    getPlaylistInfo() {
      let playlistData = this.listGenre.find((item) => item.id == this.playlistId);
      playlistData = playlistData || {};

      this.playlistInfo = {
        name: playlistData.name,
        description: playlistData.description || playlistData.content,
        cover: playlistData.img_thumb || playlistData.img_banner
      };
    },
    async getPlaylistData() {
      try {
        let playlistId = this.$route.params.id;
        this.playlistId = playlistId;
        this.getPlaylistInfo();

        let res = await service.get("/category/detail-category?page=1&number_per_page=20&category_id=18", {
          params: {
            page: 1,
            number_per_page: 20,
            category_id: playlistId
          }
        });

        let data = res && res.data && res.data.code === 200 && res.data.data ? res.data.data : {};
        let listMusic = data.data || [];

        this.playlistInfo.view = data.views;
        this.playlistInfo.like = data.like;
        this.playlistInfo.song = data.totalSong;

        listMusic = listMusic.map((item, ind) => {
          let { id, id: key, name, artist_name: artist, song_file: play, img_thumb: photo } = item;
          let date = item.created_at
            .split(" ")[0]
            .split("-")
            .join("/");
          return {
            id,
            key,
            name,
            artist: artist || "Unknown",
            date,
            duration: "0:00",
            photo,
            play
          };
        });
        this.listMusic = listMusic;
        listMusic.forEach((item, ind) => {
          let sound = new Howl({
            src: [item.play],
            html5: true
          });
          sound.on("load", () => {
            this.listMusic[ind].duration = this.formatterTimeGl(sound.duration());
          });
        });
      } catch (error) {
        console.log(error);
      }
    }
  },
  mounted() {
    let listGenre = this.$store.state.app.listGenre || [];

    this.listGenre = listGenre;
    this.getPlaylistData();
  }
};
</script>
